#include <orbit/orbit.h>
#include <stdio.h>
#include "calculator.h"


int
main ( int argc, char *argv[] )
{

	calculator calculator_client;

	CORBA_Environment ev;
	CORBA_ORB orb;

	CORBA_long nums[5]         = { 2, 3, 5, 7, 11 };
	calculator_Numbers numbers = { 5L, 5L, (CORBA_long*)nums }; 

	CORBA_exception_init(&ev);
	orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);
	
	if ( argc < 2 ) {

		printf("Need a binding ID thing as argv[1]\n");
		return 1;
	}

	calculator_client = CORBA_ORB_string_to_object(orb, argv[1], &ev);
	if (!calculator_client) {
		printf("Cannot bind to %s\n", argv[1]);
		return 1;
	}

	/*
	 *  do some tests
	 *  for the first two, we're too lazy to check for exceptions
	 *  (the ev parameter)
	 */
	printf ( "3 + 4                  = %d\n", calculator_add ( calculator_client, 3, 4, &ev));
	printf ( "sum ( 2, 3, 5, 7, 11 ) = %d\n", calculator_sum ( calculator_client, &numbers, &ev));

	printf ( "3/4                    = %f ", calculator_divide ( calculator_client, 3, 4, &ev));
	if ( ev._major == CORBA_NO_EXCEPTION ) 
		printf ( "(no exception)\n");
	else 
		printf ( "(exception occured)\n");
	
	printf ( "3/0                    = %f ", calculator_divide ( calculator_client, 3, 0, &ev));
	if ( ev._major == CORBA_NO_EXCEPTION ) 
		printf ( "(no exception)\n");
	else 
		printf ( "(exception occured)\n");
	
	
	/* cleanup*/
	CORBA_Object_release(calculator_client, &ev);
	CORBA_Object_release((CORBA_Object)orb, &ev);
	CORBA_exception_free ( &ev );

	return 0;
}
