/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */

#include <stdio.h>
#include <bonobo-activation/bonobo-activation.h>
#include "calculator.h"

extern calculator impl_create (PortableServer_POA poa,  CORBA_Environment * ev);

int
main (int argc, char* argv[])
{
	PortableServer_POA poa;
	calculator objref;

	CORBA_Environment ev;
	CORBA_ORB orb;

	CORBA_exception_init (&ev);
	orb = bonobo_activation_init (argc, argv);

	/* bootstrap the poa */
	poa = (PortableServer_POA) CORBA_ORB_resolve_initial_references ( orb, "RootPOA", &ev );
	PortableServer_POAManager_activate (PortableServer_POA__get_the_POAManager ( poa, &ev ), &ev);
	
	/* create the implementation */
	objref = impl_create (poa, &ev);
	if (objref == CORBA_OBJECT_NIL
	    || ev._major != CORBA_NO_EXCEPTION) {
		printf ( "Cannot get objref\n" );
		return 1;
	}
	
	/* tell oaf about this new implementation */
	bonobo_activation_active_server_register ("OAFIID:calculator:20000527", objref);

	/* get into glib main loop so that the server can actually receive requests */
	while (1)
		g_main_iteration (TRUE);
	
	/* destroy this implementation. We will never do this in this particuliar 
	   code because the server will never know when to destroy itself but if he 
	   wanted to do it, this is what he should do.

	   bonobo_activation_active_server_unregister ("OAFIID:calculator:20000527", objref);
	   impl_calculator__destroy (poa, obj_ref, &ev);
	*/
	return 0;
}





