/*
 * calculator-exe_server.c
 */

#include <stdio.h>
#include "calculator.h"

// function added in calculator-impl.c
extern calculator impl_create (PortableServer_POA poa, CORBA_Environment * ev);

calculator calculator_client = CORBA_OBJECT_NIL;

int
main ( int argc, char* argv[] )
{
	PortableServer_POA poa;

	CORBA_Environment ev;
	char *retval;
	CORBA_ORB orb;
    
	CORBA_exception_init(&ev);
	orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);
    
	poa = (PortableServer_POA)CORBA_ORB_resolve_initial_references(orb, 
								       "RootPOA", 
								       &ev);
	PortableServer_POAManager_activate(PortableServer_POA__get_the_POAManager(poa,
										  &ev), &ev);
	calculator_client = impl_create (poa, &ev);

	if (!calculator_client) {
		printf("Cannot get objref\n");
		return 1;
	}

	retval = CORBA_ORB_object_to_string(orb, calculator_client, &ev);
	g_print("%s\n", retval); fflush(stdout);

	CORBA_free(retval);
	CORBA_ORB_run(orb, &ev);

	return 0;
} 
