CC=gcc
DEPS    += ORBit-2.0 glib
CFLAGS  += -g -Wall `pkg-config --cflags $(DEPS)`
LDFLAGS += `pkg-config --libs $(DEPS)`
IDL_FLAGS += 

ifeq ($(OUTPUT_TYPE),shlib)
LDFLAGS += -shared
else
endif


IDL_HEADER_FILES = $(IDL_FILES:.idl=.h)
IDL_COMMONS = $(IDL_FILES:.idl=-common.c)
IDL_SKELS = $(IDL_FILES:.idl=-skels.c)
IDL_STUBS = $(IDL_FILES:.idl=-stubs.c)

CLIENT_SOURCES=$(IDL_COMMONS) $(IDL_STUBS)
SERVER_SOURCES=$(IDL_COMMONS) $(IDL_SKELS)


ifeq (client,$(CORBA_TYPE))
INTERNAL_SOURCES=$(CLIENT_SOURCES)
else
INTERNAL_SOURCES=$(SERVER_SOURCES)
endif

OBJECTS=$(addsuffix .o,$(basename $(INTERNAL_SOURCES) $(SOURCES)))

all: $(TARGET)

$(TARGET): $(OBJECTS)
	$(CC) $(LDFLAGS) $^ -o $@

%.o: %.c $(INTERNAL_SOURCES)
	$(CC) -c $< $(CFLAGS)

%.h %-common.c %-stubs.c %-skels.c: $(IDL_DIR)%.idl
	@echo "IDL_DIR: $(IDL_DIR)"
	@echo "IDL file: $<"
	@-(rm -f $(*).h $(*)-common.c $(*)-stubs.c $(*)-skels.c|| true) > /dev/null
	@orbit-idl-2 $(IDL_FLAGS)  --deps $(*D)/.deps/$(*F).idl.P $<

clean:
	@rm -f *.o *~ $(TARGET) $(IDL_COMMONS) $(IDL_STUBS) $(IDL_SKELS) $(IDL_HEADER_FILES) 2>&1 >/dev/null 



#####################################################
## make dist. Build a tarball release for our code...
#####################################################

tar:
	@echo "   copying files..."
	@for d in $(SOURCES) $(EXTRA) Makefile; do \
		cp $$d $(DEST_DIR); \
	done
	@echo "      done..."
#	echo $(DEST_DIR)
